#property copyright "*"
#property link      "*"
#property indicator_separate_window
#property indicator_buffers 3
#property indicator_color1 Red
#property indicator_color2 Yellow

#property indicator_level1 80
#property indicator_level2 20
extern int  NextTimeFrame=60;
extern int  K=5,D=3,S=3,Method=0,Price=0;


//---- buffers
double ExtMapBuffer1[];
double ExtMapBuffer2[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   SetIndexStyle(0,DRAW_LINE);
   SetIndexBuffer(0,ExtMapBuffer1);
   SetIndexStyle(1,DRAW_LINE);
   SetIndexBuffer(1,ExtMapBuffer2);
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   datetime daytimes[];
   static bool err;
   ArrayCopySeries(daytimes,MODE_TIME,Symbol(),NextTimeFrame);
      if(GetLastError()==4066){
         err=true;
         return(0);
      }
	int limit=Bars-IndicatorCounted();
      if(err){
         err=false;
         limit=Bars;
      }
	int NTFBarNum=iBarShift(NULL,NextTimeFrame,Time[limit-1],false);
	datetime NTFTime=iTime(NULL,NextTimeFrame,NTFBarNum);
	limit=iBarShift(NULL,0,NTFTime)+1;
	
	for(int i=limit-1;i>=0;i--){
      int BarNum=iBarShift(NULL,NextTimeFrame,Time[i],false); 
      ExtMapBuffer1[i]=iStochastic(NULL,NextTimeFrame,K,D,S,Method,Price,0,BarNum);
      ExtMapBuffer2[i]=iStochastic(NULL,NextTimeFrame,K,D,S,Method,Price,1,BarNum);
   }
   return(0);
  }
//+------------------------------------------------------------------+